VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cwDetail"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Const ElmDistance& = 30, ElmRightOffs& = 110

Private i As Long, FList As cArrayList
Private WithEvents mDS As cDataSource
Attribute mDS.VB_VarHelpID = -1
Private Frame As Object

Private WithEvents W As cWidgetBase
Attribute W.VB_VarHelpID = -1

Private Sub Class_Initialize()
  Set Frame = WCreate("cwFrame")
      Frame.Caption = "Detail-Data"
  
  Set W = Frame.Widget 'we inherit visually now from the cwFrame instead of the usual 'Cairo.WidgetBase' instance
      W.FontBold = True
      W.ForwardFocus = True
      W.BackColor = &HF8F8F8
      
  Set FList = New_c.ArrayList(vbString, "Item Number", "Type", "Item Description", "Unit of Measure", "Unit Price")
  For i = 0 To FList.Count - 1
    Widgets.Add(WCreate("cwTextBox"), "tb_" & i).Locked = True
  Next i
End Sub
Public Property Get Widget() As cWidgetBase
  Set Widget = W
End Property
Public Property Get Widgets() As cWidgets
  Set Widgets = W.Widgets
End Property

Public Property Get DataSource() As cDataSource
  Set DataSource = mDS
End Property
Public Property Set DataSource(DS As cDataSource)
  Set mDS = DS
  
  For i = 0 To FList.Count - 1
    If mDS Is Nothing Then Widgets("tb_" & i).Text = "" Else Widgets("tb_" & i).Text = mDS.FieldValue(i)
  Next i
End Property
 
Private Sub W_Resize()
  For i = 0 To FList.Count - 1
    Widgets("tb_" & i).Widget.Move ElmRightOffs + 10, i * ElmDistance + 25, W.Width - ElmRightOffs - 35, 24
  Next i
End Sub
 
Private Sub W_Paint(CC As vbRichClient5.cCairoContext, ByVal xAbs As Single, ByVal yAbs As Single, ByVal dx_Aligned As Single, ByVal dy_Aligned As Single, UserObj As Object)
  W.SelectFontSettingsInto CC
  For i = 0 To FList.Count - 1 'draw the Caption-Strings of our "virtual Labels" (sitting in a simple ArrayList: FList)
    CC.DrawText 0, i * ElmDistance + 37, ElmRightOffs, ElmDistance, FList(i) & ":", True, vbRightJustify
  Next i
End Sub
