Attribute VB_Name = "modPanelLayoutDefs"
Option Explicit

'just the usual Panel-Definition-module, where we pre-set the separate regions on a given "MainForm-View"

Private Const DebugFrameOffsPxl As Long = 0 '<- only for debugging/controlling (set this to 0, to avoid showing the TestFrame-Borders)

Public Function CreatePanelLayoutView() As Collection
  Set CreatePanelLayoutView = New Collection

  Dim PL As cPanelLayout
  Set PL = Cairo.CreatePanelLayout("Panel-LayoutView1", , vbWhite, DebugFrameOffsPxl)

    PL.DefinePanel "pnlRight", , "pnlToolBar", -0.575, "pnlStatusBar"  'the def for pnlMain takes what's left-over (between "pnlLeft", "pnlToolBar" and "pnlStatusBar")
    PL.DefinePanel "pnlStatusBar", , , , -49 'negative Params in dx or dy mean, that this Panel is created "from the Bottom or the Right" of the hosting Form
    PL.DefinePanel "pnlTop", , , , 50 'when we leave out a Param (here the dx), the Layouter takes "everything available" (in this case the Width)
    PL.DefinePanel "pnlToolBar", , "pnlTop", , 30  'when we leave out a Param (here the dx), the Layouter takes "everything available" (in this case the Width)
    PL.DefinePanel "pnlLeft", , "pnlToolBar", "pnlRight", "pnlStatusBar"    'Values < 1 (in this case the dx-Param) mean, that the resizing-behaviour is "relative"

  CreatePanelLayoutView.Add PL, PL.Key
End Function
